/*
 * Copyright  2001,2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.tools.ant.taskdefs.optional.sitraka;

/**
 * String utilities method.
 */
public final class StringUtil {
    /** private constructor, it's a utility class */
    private StringUtil() {
    }

    /**
     * Replaces all occurences of <tt>find</tt> with <tt>replacement</tt> in the
     * source StringBuffer.
     * @param src the original string buffer to modify.
     * @param find the string to be replaced.
     * @param replacement the replacement string for <tt>find</tt> matches.
     */
    public static void replace(StringBuffer src, String find, String replacement) {
        int index = 0;
        while (index < src.length()) {
            index = src.toString().indexOf(find, index);
            if (index == -1) {
                break;
            }
            src.delete(index, index + find.length());
            src.insert(index, replacement);
            index += replacement.length() + 1;
        }
    }
}
